;;------------------------------------
;;       Crear entidad Anon.         |
;;------------------------------------

.macro DefineEntityAnnon _type, _x, _y, _vx, _vy, _w, _h, _sprite, _jump, _lastPtr, _dir, _lifes
   .db _type
   .db _x
   .db _y
   .db _vx
   .db _vy
   .db _w
   .db _h
   .dw _sprite
   .db _jump
   .dw _lastPtr
   .db _dir
   .db _lifes
.endm



;;------------------------------------
;; Crear entidad con etiqueta _name  |
;;------------------------------------

.macro DefineEntity _name, _type, _x, _y, _vx, _vy, _w, _h, _sprite, _jump, _lastPtr, _dir, _lifes
_name::
   DefineEntityAnnon _type, _x, _y, _vx, _vy, _w, _h, _sprite, _jump, _lastPtr, _dir, _lifes
.endm



;;------------------------------------
;;      Array entidades Anon.        |
;;------------------------------------

.macro DefineEntityArray _name, _N
_name::
   .rept _N
      DefineEntityAnnon 0x00, 0xDE, 0xAD, 0xDE, 0xAD, 0xDE, 0xAD, 0xDE00, 0xAD, 0xC000, 0x00, 0x00
   .endm
.endm



;;------------------------------------
;;         Variables entidad         |
;;------------------------------------

e_type     = 0
e_x        = 1
e_y        = 2
e_vx       = 3
e_vy       = 4
e_w        = 5
e_h        = 6
e_sp_l     = 7
e_sp_h     = 8
e_jump     = 9
e_lastPtr  = 10
e_dir      = 12
e_vidas    = 13



;;------------------------------------
;;          Espacio entidad          |
;;------------------------------------

sizeof_e   = 14



;;------------------------------------
;;         Espacio máscaras          |
;;------------------------------------

e_type_alive_bit    = 7
e_type_physics_bit  = 6
e_type_render_bit   = 5
e_type_collider_bit = 4
e_type_shootable_bit = 3
e_type_input_bit    = 2
e_type_dead_bit     = 1



;;------------------------------------
;;             Máscaras              |
;;------------------------------------

e_type_invalid      = 0x00
e_type_default      = 0xFF
e_type_alive_mask   = (1 << e_type_alive_bit)
e_type_physics_mask = (1 << e_type_physics_bit)
e_type_render_mask  = (1 << e_type_render_bit)
e_type_collide_mask = (1 << e_type_collider_bit)
e_type_shootable_mask = (1 << e_type_shootable_bit)
e_type_input_mask   = (1 << e_type_input_bit)
e_type_dead_mask    = (1 << e_type_dead_bit)



;;------------------------------------
;;           Tipos entidad           |
;;------------------------------------

e_type_player    = e_type_physics_mask | e_type_collide_mask | e_type_render_mask | e_type_input_mask
e_type_enemy     = e_type_physics_mask | e_type_collide_mask | e_type_alive_mask   | e_type_render_mask | e_type_shootable_mask
e_type_boss      = e_type_enemy | e_type_shootable_mask
e_type_boss_bullet = e_type_bullet | e_type_enemy
e_type_invalid_boss_bullet = e_type_invalid
e_type_platform  = e_type_collide_mask | e_type_render_mask 
e_type_spikes    = e_type_enemy
e_type_bullet    = e_type_collide_mask | e_type_physics_mask | e_type_render_mask  | e_type_shootable_mask
e_type_invalid_bubble = e_type_invalid
e_type_invalid_enemy = e_type_invalid | e_type_dead_mask ;;---



;------------------------------------------------------------


;;------------------------------------
;;             Funciones             |
;;------------------------------------

.globl man_entity_init
.globl man_entity_create
.globl man_entity_set4destruction
.globl man_entity_destroy_one
.globl man_entity_clear

.globl man_entity_update_forall
.globl man_entity_update_forall_matching

.globl man_entity_get_from_idx
.globl man_entity_screen_pos
.globl man_entity_getArray

.globl man_entity_player_dead
.globl man_entity_getPlayer_IY
.globl man_entity_player_dec_life
.globl man_entity_set_player_life
.globl man_entity_reset_player_life


.globl _MUSIC_LOOPEND_START