;;
;; Include /man & /sys
;;
.include "cpctelera.h.s"
.include "main.h.s"
.include "sys/render.h.s"
.include "man/entity.h.s"
.include "man/game.h.s"
.include "man/level.h.s"
.include "aks2.h.s"
.include "man/interruptions.h.s"
.include "assets/sprites/death_cover.h.s"

max_entities == 15




;; Inicializa Entity_Array, y ptr al ultimo
man_entity_init::

    _num_entities:: .db 0           

    DefineEntityArray _entity_array, max_entities
    _last_elem_ptr:: .dw _entity_array           

    ret



;; Nueva entidad
man_entity_create::

    ld      de, (#_last_elem_ptr)
    ld      bc, #sizeof_e
    ldir

    ld      a, (#_num_entities)
    inc     a
    ld      (#_num_entities), a

    ld      hl, (#_last_elem_ptr)
    ld      bc, #sizeof_e     
    add     hl, bc        
    ld      (#_last_elem_ptr), hl

    ret

man_entity_getPlayer_IY::

    ld      iy, #_entity_array

    ret


 ;; entity -> iy
man_entity_get_from_idx::

    inc     a
    ld      iy, #_entity_array                      
    ld      bc, #sizeof_e
_loop_getidx:
    dec      a 
    ret      z
    add     iy, bc       
    jr      _loop_getidx

  ret


man_entity_getArray::

	ld ix, #_entity_array
	ld a, (_num_entities)

	ret


;; util, screen pos
man_entity_screen_pos::

    ld     de, #screen_start            
    ld      c, e_x(iy)           
    ld      b, e_y(iy)           

    call   cpct_getScreenPtr_asm

    ld     e_lastPtr+1  (iy), h
    ld     e_lastPtr  (iy), l

    ret


;; hl = func por parametro
man_entity_update_forall::
    ld      (_func_forall), hl                 
    ld      iy, #_entity_array              

_next:
    ld      a, (iy)                         
    or      a                               
    ret     z                              

_func_forall = . + 1                           
    call    _func_forall                        

    ld     bc, #sizeof_e                    
    add    iy, bc
    jr      _next



;; Update quien coincida
man_entity_update_forall_matching::
    ld      (_func_match),   hl            
    ld      (_type_match),  a            
    ld      iy, #_entity_array             
    jr      _no_match               

_next_match:
    ld      a, (iy)                         
    or      a
    ret     z
    
_type_match = . + 1                      
    ld      b, #00                          
    ld      c, (iy)                        
    or      b                               
    sub     c                               
    jr     nz, _no_match

_func_match = . + 1                    
    call    _func_match                   

_no_match:
    ld     bc, #sizeof_e           
    add    iy, bc
    jr     _next_match



;; Cambiar máscara para destruir
man_entity_set4destruction::
    ld      e_type(ix), #(e_type_dead_mask | e_type_render_mask)

    ret



;; iy type == invalid type
man_entity_destroy_one::

    ld      e_type(ix), #e_type_invalid

    ret



;; Del array
man_entity_clear::

    ld      a, #0
    ld      (_num_entities), a
    ld      hl, #_entity_array
    ld      (_last_elem_ptr), hl

    ret



man_entity_player_dead::

    call man_entity_clear
    call sys_render_clear_screen

    aks2_soundm_setSong _MUSIC_LOOPEND_START
	call man_interruption_enableMusic

    ld hl, #_death_cover_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm

    call sys_render_print_finalscore ;print final score

    loop_death:

        call    cpct_scanKeyboard_f_asm 

        ld      hl, #Key_Esc              
        call    cpct_isKeyPressed_asm      
        jr      z, loop_death

        call sys_render_score_reset
        call man_level_clear_stage
        call man_level_0

    ret

man_entity_player_dec_life::

    call man_entity_getArray

    ld a, e_vidas(ix)
    dec a
    ld e_vidas(ix), a

    ld a, e_vidas(ix)
    xor #0
    jr z, man_entity_player_dead

    ld      e, e_lastPtr  (ix)      
    ld      d, e_lastPtr+1(ix)
    xor     a              
    ld      c, e_w(ix)             
    ld      b, e_h(ix)  
    call    cpct_drawSolidBox_asm

    ld e_x(ix), #0
    ld e_y(ix), #168
    ld e_dir(ix), #1

    ret

man_entity_set_player_life::

    call man_entity_getPlayer_IY
    ld e_vidas(iy), a

    ret

man_entity_reset_player_life::

    call man_entity_getPlayer_IY
    ld e_vidas(iy), #3

    ret