;;
;; Include /man & /sys
;;
.include "cpctelera.h.s"
.include "main.h.s"
.include "man/game.h.s"
.include "man/entity.h.s"
.include "man/enemy.h.s"
.include "sys/ia.h.s"
.include "sys/shoot.h.s"
.include "sys/render.h.s"
.include "sys/physics.h.s"
.include "sys/input.h.s"
.include "sys/animation.h.s"
.include "sys/collision.h.s"
.include "man/level.h.s"
.include "man/interruptions.h.s"
.include "aks2.h.s"

.include "assets/sprites/menu_cover.h.s"

man_game_init::
    
    call sys_render_init
    call man_interruption_init

    aks2_soundm_setSong _MUSIC_LOOPMAIN_START
	call man_interruption_enableMusic

    ld hl, #_menu_cover_end
    ld de, #0xFFFF
    call cpct_zx7b_decrunch_s_asm

    loop_menu:

        call    cpct_scanKeyboard_f_asm 

        ld      hl, #Key_Space              
        call    cpct_isKeyPressed_asm      
        jr      z, loop_menu

        call  man_game_load_level  
        ret

man_game_load_level::

    call  man_entity_init
    call  sys_render_clear_screen
    call  sys_render_hud

    ;; cambiar para testear nivel
    call man_level_0

    ret

;; UPDATE -> RENDER - INPUT - PHYSICS
man_game_update::

    call    sys_render_update
    
    call    man_entity_getArray
    call    sys_input_update
    
    call    sys_physics_update

    call    man_entity_getArray
    call    sys_ia_update

    call    man_entity_getArray
    call    sys_shoot_update

    call    man_entity_getArray
    call    sys_animation_update

    call    man_entity_getArray
    call    sys_collision_update


    call    man_level_check_next_level

    ret