;;
;; Include /man & /sys
;;
.include "main.h.s"
.include "man/entity.h.s"
.include "man/level.h.s"
.include "sys/render.h.s"
.include "sys/input.h.s"
.include "sys/collision.h.s"

;https://www.youtube.com/watch?v=g_ttKAmcQY0

;;comprobar si dos entidades colisionan
;; coger x y de sprite1 , x y de sprite2
;;               ix            iy



sys_collision_update::

    ld      hl, #sys_collision_update_one_entity
    ld       a, #e_type_collide_mask
    call    man_entity_update_forall_matching 

    ret

;;;https://www.youtube.com/watch?v=ciXJRspKzAs&t=1632s
;;;
;;; Por añadir colision con entidad enemiga, player -> dead mask -> destroy
;;;
sys_collision_update_one_entity::

    ;Eje x
    ld      a, e_x(ix)                                         
    add     e_w(ix)                                                
    cp      e_x(iy)
    jr      c, _no_collision                             

    ;Eje y
    ld      a, e_y(ix)
    add     e_h(ix)
    cp      e_y(iy)
    jr      c, _no_collision

    
    ;Eje x
    ld      a, e_x(iy)                                         
    add     e_w(iy)                                                
    cp      e_x(ix)
    jr      c, _no_collision                             

    ;Eje y
    ld      a, e_y(iy)
    add     e_h(iy)
    cp      e_y(ix)
    jr      c, _no_collision

    ld      a, e_vidas(iy)  ;; flag para saber si es un pincho
    xor     #1  ;; xor, si iguales 0, distinto es 1
    jr      z, _no_collision
    
    ld      a, e_type(iy)
    and     #1
    call    z, sys_collision_check 

    ld      a, e_type(iy)
    xor     #e_type_boss
    call    z, _collision_boss 

_no_collision:

    ld      a, #0x00
    ld      (0xC000), a

    ret

_collision_boss:

    ;; No volver a renderizar
    ld e_type(ix), #e_type_invalid_bubble

     ;; actualizar score
    call sys_render_score_update
    
    ;; quitar uno de contador enemigos
    call man_level_dec_enemy

    ;; hud colores decrementar

    ret


;;Plataforma error
sys_collision_check::

    ld      a, e_y(ix)
    ld      b, e_y(iy)
    cp      b
    jr      nc, _end_check

    ld      a, #v_jump
    add     e_vy(ix)
    jr      c, _end_check

fix_y:

    ld      a, e_y(iy)
    sub     e_h(ix)
    ld      e_y(ix), a
    ld      e_vy(ix), #0
    ld      e_jump(ix), #1

    ld      a, e_type(ix)
    xor     #e_type_bullet  ;; xor, si iguales 0, distinto es 1
    jr      z, _bullet_collide_enemy
    
_end_check:

    ret

_bullet_collide_enemy::

    ;; No volver a renderizar
    ld e_type(ix), #e_type_invalid_bubble
    ld e_type(iy), #e_type_invalid_enemy

    ;; Borrar de pantalla
    ld      e, e_lastPtr  (ix)      
    ld      d, e_lastPtr+1(ix)
    xor     a              
    ld      c, e_w(ix)             
    ld      b, e_h(ix)  
    call    cpct_drawSolidBox_asm

    ld      e, e_lastPtr  (iy)      
    ld      d, e_lastPtr+1(iy)
    xor     a              
    ld      c, e_w(iy)             
    ld      b, e_h(iy)  
    call    cpct_drawSolidBox_asm

    ;; actualizar score
    call sys_render_score_update

    ;; quitar uno de contador enemigos
    call man_level_dec_enemy

    end_col_enemy:

        ret




