;;
;; Include /man & /sys
;;
.include "cpctelera.h.s"
.include "main.h.s"
.include "sys/input.h.s"
.include "sys/shoot.h.s"
.include "man/entity.h.s"
.include "man/level.h.s"

;; Actualizar inputs vx, vy por teclado
sys_input_update::

    ld      a, e_type(ix)
    xor     #e_type_player  ;; xor, si iguales 0, distinto es 1
    jr      z, Update_Input

Update_Input:

    ld      e_vx(ix), #0 ;RESET VX
    call    cpct_scanKeyboard_f_asm    

    ld      hl, #Key_O              
    call    cpct_isKeyPressed_asm      
    jr      z, A_NotPressed

;; MOV IZQ
A_Pressed:
    ld      e_vx(ix),  #left
    ld      e_dir(ix), #left          

A_NotPressed:

    ld      hl, #Key_P            
    call    cpct_isKeyPressed_asm      
    jr      z, D_NotPressed

;; MOV DER
D_Pressed:
    ld      e_vx(ix),  #right    
    ld      e_dir(ix), #right       

D_NotPressed:
    dec     e_jump(ix)  ;; No saltos infinitos
    ret     nz 

    ld      hl, #Key_Q       
    call    cpct_isKeyPressed_asm      
    jr      z, W_NotPressed

;; MOV ARRIBA
W_Pressed:
    ld      e_vy(ix), #v_jump 

W_NotPressed:
    ld      hl, #Key_X      
    call    cpct_isKeyPressed_asm      
    jr      z, Space_NotPressed

Space_Pressed:
    ;; añadir x, y, y dir->vx
    ld   d, e_x(ix)
    ld   e, e_y(ix)

    ld   h, e_sp_l(ix)
    ld   l, e_dir(ix)

    call sys_player_set_shoot

Space_NotPressed:
    ret