;;
;; Include /man & /sys
;;
.include "cpctelera.h.s"
.include "main.h.s"
.include "sys/render.h.s"
.include "man/entity.h.s"

.globl _g_palette

.globl _sp_vida1
.globl _sp_vida2
.globl _sp_vida3

.globl _sp_floor

.globl _sp_vidaplayer1
.globl _sp_vidaplayer2
.globl _sp_vidaplayer3

tutorial: .asciz "Training";
matalos:  .asciz "Kill 'em all"
blob:  .asciz "Kill the blob!"

larcenas: .asciz "Pay the bribe"
youdead: .asciz "FINAL SCORE"

puntuacion: .asciz "0000" 
puntuacion_pos:       .dw 0x0000


;;Inicializador render
sys_render_init::
    
    call cpct_disableFirmware_asm ;; Disable firmware to prevent it from interfering with string drawing

    ld   c, #0
    call cpct_setVideoMode_asm ;modo 0

    ld  hl, #_g_palette
    ld  de, #16
    call cpct_setPalette_asm ;cargar paleta

    cpctm_setBorder_asm  HW_BLACK

    ret

sys_render_clear_screen::

    ld  de, #0xC000
    ld  a, #0x00
    ld  b, #200
    ld  c, #40
    call cpct_drawSolidBox_asm 

    ld  de, #0xC028
    ld  a, #0x00
    ld  b, #200
    ld  c, #40
    call cpct_drawSolidBox_asm 

    ret


sys_render_update_life_boss::

    xor #2
    jr z, _dos_vida

    xor #1
    jr z, _una_vida                           

    ld     de, #screen_start 
    ld      c, #64     
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_vida3
    ld      b, #8   ;alto bytes
    ld      c, #16  ;ancho
    call    cpct_drawSprite_asm

    ret

_una_vida:

    ld     de, #screen_start 
    ld      c, #64     
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_vida1
    ld      b, #8   ;alto bytes
    ld      c, #16  ;ancho
    call    cpct_drawSprite_asm

    ret

_dos_vida:               

    ld     de, #screen_start 
    ld      c, #64     
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_vida2
    ld      b, #8   ;alto bytes
    ld      c, #16  ;ancho
    call    cpct_drawSprite_asm

    ret



sys_render_update_life_player::

    xor #2
    jr z, _dos_vida_player

    xor #1
    jr z, _tres_vida_player                       

    ld     de, #screen_start 
    ld      c, #1     
    ld      b, #12                                   
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_vidaplayer1
    ld      b, #8   ;alto bytes
    ld      c, #14  ;ancho
    call    cpct_drawSprite_asm

    ret

_tres_vida_player:

    ld     de, #screen_start 
    ld      c, #1     
    ld      b, #12                                   
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_vidaplayer3
    ld      b, #8   ;alto bytes
    ld      c, #14  ;ancho
    call    cpct_drawSprite_asm

    ret

_dos_vida_player:               

    ld     de, #screen_start 
    ld      c, #1     
    ld      b, #12                                   
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_vidaplayer2
    ld      b, #8   ;alto bytes
    ld      c, #14  ;ancho
    call    cpct_drawSprite_asm

    ret


;;Pinta String -> menu, hud?
sys_render_hud::


    ld  h, #00
	ld  l, #15
	call cpct_setDrawCharM0_asm

	ld  de, #screen_start  
    ld    b, #00
    ld    c, #00
    call cpct_getScreenPtr_asm 

    ld  (puntuacion_pos), hl

    ld   iy, #puntuacion
    call cpct_drawStringM0_asm


    ;; cambiar por sprites de suelo/hud
    ld      de, #0xC730
    ld      b, #0          
    ld      c, #0                         
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_floor
    ld      b, #16   ;alto bytes
    ld      c, #20  ;ancho
    call    cpct_drawSprite_asm

    ld      de, #0xC730
    ld      b, #0          
    ld      c, #20                         
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_floor
    ld      b, #16   ;alto bytes
    ld      c, #20  ;ancho
    call    cpct_drawSprite_asm

    ld      de, #0xC730
    ld      b, #0          
    ld      c, #40                         
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_floor
    ld      b, #16   ;alto bytes
    ld      c, #20  ;ancho
    call    cpct_drawSprite_asm

    ld      de, #0xC730
    ld      b, #0          
    ld      c, #60                         
    call    cpct_getScreenPtr_asm  

    ex     de, hl
    ld      hl, #_sp_floor
    ld      b, #16   ;alto bytes
    ld      c, #20  ;ancho
    call    cpct_drawSprite_asm

    ret



sys_render_update::        

    call    man_entity_getArray
    call    sys_render_update_one_entity                

    ret


;;Actualizar todo
sys_render_update_all::

    ld      hl, #sys_render_update_one_entity     
    call    man_entity_update_forall   

    ret


;;Dibuja una entidad
sys_render_update_one_entity::

    ld (_ent_counter), a



_update_loop:

    ;;
    ld      a, e_type(ix)
    xor     #e_type_invalid_bubble     ;; xor, si iguales 0, distinto es 1
    jr      z, _next_one

    ld      a, e_type(ix)
    xor     #e_type_invalid_enemy     ;; xor, si iguales 0, distinto es 1
    jr      z, _next_one

    ;NO dejar rastros en movimiento
    call    sys_render_update_one_entity_clear

    ld     de, #screen_start                         
    ld      c, e_x(ix)     
    ld      b, e_y(ix)                                      
    call    cpct_getScreenPtr_asm                             


    ex     de, hl
    ld      l, e_sp_l(ix)
    ld      h, e_sp_h(ix)
    ld      b, e_h(ix)   ;alto bytes
    ld      c, e_w(ix)  ;ancho
    ;ld bc, #0x0804
    call    cpct_drawSprite_asm

_next_one:
    _ent_counter = .+1 ;;
        ld a, #0
        dec a
        ret z

        ld (_ent_counter), a
        ld bc, #sizeof_e
        add ix, bc
        
        jr _update_loop


;; Borra entidad, caja negra(color fondo)
sys_render_update_one_entity_clear::

    ld      e, e_lastPtr  (ix)      
    ld      d, e_lastPtr+1(ix)
    xor     a              
    ld      c, e_w(ix)             
    ld      b, e_h(ix)  
    call    cpct_drawSolidBox_asm
    
    ret


sys_render_print_tutorial::
    ld h, #00
    ld l, #15
    call cpct_setDrawCharM0_asm


    ld     de, #screen_start 
    ld      c, #45     
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ld iy, #tutorial
    call cpct_drawStringM0_asm

    ret

sys_render_print_killem::
    ld h, #00
    ld l, #15
    call cpct_setDrawCharM0_asm


    ld     de, #screen_start 
    ld      c, #32 
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ld iy, #matalos
    call cpct_drawStringM0_asm

    ret

sys_render_print_egg::
    ld h, #00
    ld l, #15
    call cpct_setDrawCharM0_asm


    ld     de, #screen_start 
    ld      c, #26 
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ld iy, #larcenas
    call cpct_drawStringM0_asm

    ret

sys_render_print_killblob::
    ld h, #00
    ld l, #15
    call cpct_setDrawCharM0_asm


    ld     de, #screen_start 
    ld      c, #25 
    ld      b, #0                                   
    call    cpct_getScreenPtr_asm  

    ld iy, #blob
    call cpct_drawStringM0_asm

    ret


sys_render_print_finalscore::
    ld h, #00
    ld l, #15
    call cpct_setDrawCharM0_asm


    ld     de, #screen_start 
    ld      c, #18 
    ld      b, #140                                   
    call    cpct_getScreenPtr_asm  

    ld iy, #youdead
    call cpct_drawStringM0_asm


    ld  h, #00
	ld  l, #15
	call cpct_setDrawCharM0_asm

	ld  de, #screen_start  
    ld    b, #160
    ld    c, #33
    call cpct_getScreenPtr_asm 

    ld  (puntuacion_pos), hl

    ld   iy, #puntuacion
    call cpct_drawStringM0_asm

    ret



sys_render_score_update::

    ld   ix, #puntuacion+2
    ld   b, #1

puntuacion_update:

    ld   a, (ix)
    inc  a
    cp   #0x3A
    jp   nz, nueva_puntuacion

    inc  b
    ld   a, #0x30
    ld   (ix), a
    dec  ix
    jp   puntuacion_update

nueva_puntuacion:

    ld   (ix), a
    ld   hl, (puntuacion_pos)
    ld   iy, #puntuacion      
    call cpct_drawStringM0_asm

    ret


sys_render_score_reset::

    ld   hl, #puntuacion
    ld   (hl), #0x30
    ld   d, h
    ld   e, l
    inc  de
    ld   bc, #3
    ldir

    ld   hl, (puntuacion_pos)
    ld   iy, #puntuacion      
    call cpct_drawStringM0_asm

    ret