;;
;; Include /man & /sys
;;
.include "main.h.s"
.include "man/entity.h.s"
.include "man/enemy.h.s"
.include "sys/collision.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"

;; Update de la bala
sys_shoot_update::

    ld (_entid_counter), a

_update_shoot:

    ld      a, e_type(ix)
    xor     #e_type_bullet     ;; xor, si iguales 0, distinto es 1
    jr      nz, _end_shoot

    call    sys_physics_prevLoc
    
    ld      h, e_y(ix)
    ld      a, #screen_width
    sub     e_w(ix)
    ld      c, a
    ld      a, e_x(ix)
    add     e_vx(ix)     
    cp      c     
    jr      nc, invalid_x_shot

valid_x_shot:

        ld      e_x(ix), a          
        call    sys_shoot_collide_enemy   

        jr      _end_shoot
invalid_x_shot:

        ld      a, e_vx(ix)
        ld      b, e_vx(ix)
        add     a, b
        jr      c, start_x_shot
end_x_shot:
        ld      e_type(ix), #e_type_invalid_bubble
        ld      e, e_lastPtr  (ix)      
        ld      d, e_lastPtr+1(ix)
        xor     a              
        ld      c, e_w(ix)             
        ld      b, e_h(ix)  
        call    cpct_drawSolidBox_asm
        jr      _end_shoot 
start_x_shot:
        ld      e_type(ix), #e_type_invalid_bubble
        ld      e, e_lastPtr  (ix)      
        ld      d, e_lastPtr+1(ix)
        xor     a              
        ld      c, e_w(ix)             
        ld      b, e_h(ix)  
        call    cpct_drawSolidBox_asm
        jr      _end_shoot 

_end_shoot:

    _entid_counter = .+1 ;;
        ld a, #0
        dec a
        ret z

        ld (_entid_counter), a
        ld bc, #sizeof_e
        add ix, bc
        
        jr _update_shoot






;; bucle para encontrar entidad shoot y añadirle sus nuevos params
sys_player_set_shoot::

    call    man_entity_getArray
    ld (_entit_counter), a

_update_loop_shoot:

    ;; si player seguimos ejec normal, si otro tipo -> sig entidad
    ;; guardar para gestionar mov enemigo y bala-burbuja
    ld      a, e_type(ix)
    xor     #e_type_invalid_bubble     ;; xor, si iguales 0, distinto es 1
    jr      nz, _end_update_shot

    ld      e_type(ix), #e_type_bullet

    ld      e_y(ix), e
    ld      e_vx(ix), l 

    ld a, l    ;; si dir -1 izq, 1 der
    dec a

    jr nz, _goto_left     ;; change dir de la burbuja

    ld      a, d
    add     #7            ;; distancia burbuja a player
    ld      e_x(ix), a
    ld      e_vx(ix), #2 
    jr      _end_update_shot

_goto_left:

    ld      a, d
    sub     #4            ;; distancia burbuja a player
    ld      e_vx(ix), #-2
    ld      e_x(ix), a

_end_update_shot:

    _entit_counter = .+1 ;;
        ld a, #0
        dec a
        ret z

        ld (_entit_counter), a
        ld bc, #sizeof_e
        add ix, bc
        
        jr _update_loop_shoot






sys_shoot_collide_enemy::
    ld      hl, #sys_collision_update_one_entity
    ld      a, #e_type_shootable_mask
    call    man_entity_update_forall_matching
    
    ret
